import json
import copy
import random

# load data
with open("patientdata.json", "r") as file:
    patientData = json.load(file)

with open("answers.json", "r") as file:
    answers = json.load(file)

with open("questions.json", "r") as file:
    questions = json.load(file)

# is later used to check if question of id q_id should be asked according to the answers so far in anser_dictionary
def helper_func_for_check_question(dependency, answer_dictionary):
    # print("q")
    if dependency.split(".")[0] not in answer_dictionary:
        # print("w")
        return False
    if dependency.split(".")[1] in answer_dictionary[dependency.split(".")[0]]:
        return True
    return False
def check_question(q_id, answer_dictionary):
    if "or" in questions[q_id]["dependency"]:
        for dependency in [d for d in questions[q_id]["dependency"] if d != "or"]:
            if helper_func_for_check_question(dependency, answer_dictionary):
                return True
    else: 
        for dependency in questions[q_id]["dependency"]:
            # print(dependency)
            if not helper_func_for_check_question(dependency, answer_dictionary):
                return False
        return True
    return False

# to stop the infinite loop coming up
stop_variable = False

while not stop_variable:
    patientName = input("patientname (write 'stop' to stop): ")
    if patientName == "stop": 
        stop_variable = True
    else:
        answer_dictionary = {}
        for q_id, question in questions.items():
            # print(answer_dictionary)
            if check_question(q_id, answer_dictionary):
                print(f"{q_id}: "+question["text"])
                for a_id, answer in answers.items():
                    if a_id.split(".")[0] == q_id:
                        if answer["text"] == "#Freitext":
                            print(f"   Freitext")
                        else:
                            a_id_pretty = a_id.split(".")[1]
                            print(f"   {a_id_pretty}: "+answer["text"]+answer["flag"])
                if question["single_choices"] == 0:
                    print("  Multiple answers possible!")
                if question["text"] == "#Freitext":
                    _input = input("Answer: ")
                    answer_dictionary[q_id] = [_input]
                else:
                    _input = input("Answer (only number): ")
                    answer_dictionary[q_id] = _input.split("; ")
        if len([patientData[idx]["id"] for idx in range(len(patientData))]) == 0:
            _id = 1
        else:
            _id = max([patientData[idx]["id"] for idx in range(len(patientData))])+1
        newPatientData = {"id": _id, "first_name": patientName.split(" ")[0], "last_name": patientName.split(" ")[1], "answers": copy.deepcopy(answer_dictionary), "waiting_time": random.randint(1,45)}
        patientData.append(newPatientData)


# save data
with open("patientdata.json", "w") as file:
    json.dump(patientData, file)

