import { createRouter, createWebHistory } from 'vue-router'
import Ampel from '../views/Ampel.vue'
import Login from '../views/Login.vue'
import store from '@/store'

const routes = [
  {
    path: '/ampel',
    name: 'Ampel',
    component: Ampel
  },
  {
    path: '/login',
    name: 'Login',
    component: Login
  },
]

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes
})

// Login Guard
router.beforeEach((to, from, next) => {
  if (store.getters['isAuthenticated']) {
    if (to.name === 'Login') next({name: 'Ampel'})
    else next()
  } else {
    if (to.name !== 'Login')
      next({name: 'Login'})
    else next()
  }
})

export default router

